##
## Copyright (c) 2021 The Yaook Authors.
##
## This file is part of Yaook.
## See https://yaook.cloud for further info.
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
apiVersion: batch/v1
kind: Job
metadata:
  generateName: {{ "%s-policy-validator-" | format(params.name) }}
  annotations:
    test.yaook.cloud/skip-ca-certs: "true"
spec:
  template:
    spec:
        restartPolicy: Never
        serviceAccountName: {{ dependencies['service_account'].resource_name() }}
        containers:
          - name: policy-validator
            # We cannot use the compnent for versioned_dependencies like we use it for the service_account.
            # Since we only supply one image with the default policies we can just take the first item and use the value as the image.
            image:  {{ versioned_dependencies.popitem()[1] }}
            imagePullPolicy: Always
            command:
              - bash
              - -ec
              - |
                if type /usr/venv-openstack/bin/python3 &> /dev/null; then
                  /usr/venv-openstack/bin/python3 /validator/validator.py
                else
                  python3 /validator/validator.py
                fi
            env:
              - name: REQUESTS_CA_BUNDLE
                value: /etc/pki/tls/certs/ca-bundle.crt
              - name: POLICY
                value: {{ vars.policy }}
              - name: CONFIGMAP
                value: {{ dependencies['policy'].resource_name() }}
              - name: KUBERNETES_NAMESPACE
                value: {{ namespace }}
              - name: SERVICE
                value: {{ params.name }}
              - name: RELEASE
                value: {{ target_release }}
            volumeMounts:
              - mountPath: "/validator"
                name: script
        volumes:
          - name: script
            configMap:
              name: {{ dependencies['script'].resource_name() }}
{% if crd_spec.imagePullSecrets | default(False) %}
        imagePullSecrets: {{ crd_spec.imagePullSecrets }}
{% endif %}